import { EditorView } from '@codemirror/view';
import { getTokenAtPosition, getTypeInfo } from 'graphql-language-service';
import { isMetaKeyPressed, offsetToPos } from './helpers';
import { getOpts, getSchema } from './state';
export const jump = EditorView.domEventHandlers({
    click(evt, view) {
        var _a, _b, _c;
        const schema = getSchema(view.state);
        if (!schema) {
            return;
        }
        const currentPosition = view.state.selection.main.head;
        const pos = offsetToPos(view.state.doc, currentPosition);
        const token = getTokenAtPosition(view.state.doc.toString(), pos);
        const tInfo = getTypeInfo(schema, token.state);
        const opts = getOpts(view.state);
        if ((opts === null || opts === void 0 ? void 0 : opts.onShowInDocs) && isMetaKeyPressed(evt)) {
            opts.onShowInDocs((_a = tInfo.fieldDef) === null || _a === void 0 ? void 0 : _a.name, (_b = tInfo.type) === null || _b === void 0 ? void 0 : _b.toString(), (_c = tInfo.parentType) === null || _c === void 0 ? void 0 : _c.toString());
        }
    },
});
//# sourceMappingURL=jump.js.map